package l06_interfaces;

public class AdventureTest {

	interface CanFight {
		void fight();
	}

	interface CanSwim {
		void swim();
	}

	interface CanFly {
		void fly();
	}

	static class ActionCharacter implements CanFight {
		@Override
		public void fight() {
			System.out.println("\tCan fight");
		}
	}

	static class Hero extends ActionCharacter implements CanSwim, CanFly {
		@Override
		public void swim() {
			System.out.println("\tCan swim");
		}
		@Override
		public void fly() {
			System.out.println("\tCan fly");
		}
	}

	static class Adventure {
		public static void canFightParameter(CanFight canFight) { canFight.fight(); }
		public static void canSwimParameter(CanSwim canSwim) { canSwim.swim(); }
		public static void canFlyParameter(CanFly canFly) { canFly.fly(); }
		public static void actionCharacterParameter(ActionCharacter actionCharacter) {
			actionCharacter.fight();
		}
		public static void heroParameter(Hero hero) {
			hero.fight();
			hero.swim();
			hero.fly();
		}
	}

	public static void main(String[] args) {

		Hero hero = new Hero();
		System.out.println("Interface CanFight");
		Adventure.canFightParameter(hero);	//	Treat it as a CanFight
		System.out.println("Interface CanSwim");
		Adventure.canSwimParameter(hero);	//	Treat it as a CanSwim
		System.out.println("Interface CanFly");
		Adventure.canFlyParameter(hero);	//	Treat it as a CanFly
		System.out.println("Class ActionCharacter");
		Adventure.actionCharacterParameter(hero);	//	Treat it as an ActionCharacter
		System.out.println("Class Hero");
		Adventure.heroParameter(hero);	//	Treat it as a Hero
	}
}

