package l06_interfaces;

// Extending an interface with inheritance.
public class ExtInterfaceTest {

	interface CanReduceNoise {
		void reduceNoise();
	}

	interface CanSharpen extends CanReduceNoise {
		void sharpen();
	}

	interface CanResize {
		void resize();
	}

	interface Editable extends CanSharpen, CanResize {
		void edit();
	}

	static class Graphics implements Editable {
		@Override
		public void reduceNoise() { System.out.println("\treduceNoise()"); }
		@Override
		public void sharpen() { System.out.println("\tsharpen()"); }
		@Override
		public void resize() { System.out.println("\tresize()"); }
		@Override
		public void edit() { System.out.println("\tedit()"); }
		public void extraGraphics() { System.out.println("\textraGraphics()"); }
	}

	static class ExtInterface {

		static void canReduceNoiseParameter(CanReduceNoise canReduceNoise) {
			System.out.println("fun1(CanReduceNoise):");
			canReduceNoise.reduceNoise();
			System.out.println();
		}
		static void canSharpenParameter(CanSharpen canSharpen) {
			System.out.println("fun2(CanSharpen):");
			canSharpen.reduceNoise();
			canSharpen.sharpen();
			System.out.println();
		}
		static void canResizeParameter(CanResize canResize) {
			System.out.println("fun3(CanResize):");
			canResize.resize();
			System.out.println();
		}
		static void editableParameter(Editable editable) {
			System.out.println("fun4(Editable):");
			editable.reduceNoise();
			editable.sharpen();
			editable.resize();
			editable.edit();
			System.out.println();
		}
		static void graphicsParameter(Graphics graphics) {
			System.out.println("fun5(Graphics):");
			graphics.reduceNoise();
			graphics.sharpen();
			graphics.resize();
			graphics.edit();
			graphics.extraGraphics();
			System.out.println();
		}
	}

	public static void main(String[] args) {
		Graphics graphics = new Graphics();
		ExtInterface.canReduceNoiseParameter(graphics);
		ExtInterface.canSharpenParameter(graphics);
		ExtInterface.canResizeParameter(graphics);
		ExtInterface.editableParameter(graphics);
		ExtInterface.graphicsParameter(graphics);
	}
}

