package l06_interfaces;

public class InterfaceMethodsTest {

	interface SomeInterface {
		// abstract method -> has to be overridden
		void abstractMethod();

		// default method -> may be overridden
		default void defaultMethod() {
			System.out.println("Default Method Executed");
		}

		// static method -> cannot be overridden
		static void staticMethod() {
			System.out.println("Hello, Static Method Here");
		}
	}

	static class InterfaceMethods implements SomeInterface {

		@Override
		public void abstractMethod() {
			System.out.println("Abstract Method Executed");
		}

 /*
		@Override
		public void defaultMethod() {
			SomeInterface.super.defaultMethod();	//	execute default method
			System.out.println("Overridden Default Method Executed");
		}
 */
	}

	public static void main(String[] args) {
		SomeInterface someInterface = new InterfaceMethods();
		someInterface.abstractMethod();
		someInterface.defaultMethod();
		SomeInterface.staticMethod();
	}
} 

