package l06_interfaces;

public class MusicTest {

	interface Instrument {
		void play();	//	public by default
	}

	static class Wind implements Instrument {
		@Override
		public void play() { System.out.println("Wind.play()"); }
	}

	static class Percussion implements Instrument {
		@Override
		public void play() { System.out.println("Percussion.play()"); }
	}

	static class Stringed implements Instrument {
		@Override
		public void play() { System.out.println("Stringed.play()"); }
	}

	static class Brass extends Wind {
		@Override
		public void play() { System.out.println("Brass.play()"); }
	}

	static class Woodwind extends Wind {
		@Override
		public void play() { System.out.println("Woodwind.play()"); }
	}

	static class Music {

		static void tune(Instrument instrument) {
			instrument.play();
		}

		static void tuneAll(Instrument[] instruments) {
			for (Instrument instrument : instruments) {
				tune(instrument);
			}
		}
	}


	public static void main(String[] args) {
		Instrument[] orchestra = {
			new Wind(),
			new Percussion(),
			new Stringed(),
			new Brass(),
			new Woodwind()
		};
		Music.tuneAll(orchestra);
	}
}

